- NAME
- SYNOPSIS
- DESCRIPTION
- FUNCTIONS

- px
- vars

- BUGS
- AUTHOR

# NAME

PDL::Dbg - functions to support debugging of PDL scripts

# SYNOPSIS

           use PDL;
           use PDL::Dbg;

           $c = $a->slice("5:10,2:30")->px->diagonal(3,4);
           PDL->px;

# DESCRIPTION

This packages implements a couple of functions that should come in handy when debugging your PDL scripts. They make a lot of sense while you're doing rapid prototyping of new PDL code, let's say inside the perldl shell.

# FUNCTIONS

## px

Print info about a piddle (or all known piddles)

        perldl> PDL->px
        perldl> $b += $a->clump(2)->px('clumptest')->sumover
        perldl> $a->px('%C (%A) Type: %T')

This function prints some information about piddles. It can be invoked as a class method (e.g. `PDL->px` ) or as an instance method (e.g. `$pdl->px($arg)`). If

invoked as a class method
  it prints info about all piddles found in the current package (excluding `my` variables). This comes in quite handy when you are not quite sure which pdls you have already defined, what data they hold , etc. `px` is supposed to support inheritance and prints info about all symbols for which an `isa($class)` is true. An optional string argument is interpreted as the package name for which to print symbols:

        perldl> PDL->px('PDL::Mypack')

  The default package is that of the caller.

invoked as an instance method
  it prints info about that particular piddle if `$PDL::debug` is true and returns the pdl object upon completion. It accepts an optional string argument that is simply prepended to the default info if it doesn't contain a `%` character. If, however, the argument contains a `%` then the string is passed to the `info` method to control the format of the printed information. This can be used to achieve customized output from `px`. See the documentation of `PDL::info` for further details.

The output of px will be determined by the default formatting string that is passed to the `info` method (unless you pass a string containing `%` to px when invoking as an instance method, see above). This default string is stored in `$PDL::Dbg::Infostr` and the default output format can be accordingly changed by setting this variable. If you do this you should also change the default title string that the class method branch prints at the top of the listing to match your new format string. The default title is stored in the variable `$PDL::Dbg::Title`.

For historical reasons `vars` is an alias for `px`.

## vars

Alias for `px`

# BUGS

There are probably some. Please report if you find any. Bug reports should be sent to the PDL mailing list perldl@jachw.hawaii.edu.

# AUTHOR

`Copyright(C)` 1997 Christian Soeller (c.soeller@auckland.ac.nz) All rights reserved. There is no warranty. You are allowed to redistribute this software / documentation under certain conditions. For details, see the file COPYING in the PDL distribution. If this file is separated from the PDL distribution, the copyright notice should be included in the file.